
//////////////////////////////////////////////////////////////////////////////
// CProxy_ATLButton
template <class T>
class CProxy_ATLButton : public IConnectionPointImpl<T, &DIID__ATLButton, CComUnkArray<1> >
{
public:
//methods:
//_ATLButton : IDispatch
public:
	void OnClick()
	{
		T* pT = (T*)this;
		pT->Lock();
		IUnknown** pp = m_vec.begin();
		while (pp < m_vec.end())
		{
			if (*pp != NULL)
			{
				DISPPARAMS disp = { NULL, NULL, 0, 0 };
				IDispatch* pDispatch = reinterpret_cast<IDispatch*>(*pp);
				pDispatch->Invoke(0x1, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &disp, NULL, NULL, NULL);
			}
			pp++;
		}
		pT->Unlock();
	}

};

